/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ChangeEncodingContext, EncodedRevisionTag, FieldKindIdentifier, RevisionTag } from "../../core";
import { ICodecOptions, IJsonCodec, SessionAwareCodec } from "../../codec";
import { FieldBatchCodec } from "../chunked-forest";
import { ModularChangeset } from "./modularChangeTypes";
import { FieldKindWithEditor } from "./fieldKind";
import { EncodedModularChangeset } from "./modularChangeFormat";
export declare function makeV0Codec(fieldKinds: ReadonlyMap<FieldKindIdentifier, FieldKindWithEditor>, revisionTagCodec: SessionAwareCodec<RevisionTag, EncodedRevisionTag>, fieldsCodec: FieldBatchCodec, { jsonValidator: validator }: ICodecOptions): IJsonCodec<ModularChangeset, EncodedModularChangeset, EncodedModularChangeset, ChangeEncodingContext>;
//# sourceMappingURL=modularChangeCodecs.d.ts.map