"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransactionResult = void 0;
/**
 * Describes the result of a transaction.
 * Transactions may either succeed and commit, or fail and abort.
 * @internal
 */
var TransactionResult;
(function (TransactionResult) {
    /**
     * Indicates the transaction failed.
     */
    TransactionResult[TransactionResult["Abort"] = 0] = "Abort";
    /**
     * Indicates the transaction succeeded.
     */
    TransactionResult[TransactionResult["Commit"] = 1] = "Commit";
})(TransactionResult || (exports.TransactionResult = TransactionResult = {}));
//# sourceMappingURL=transactionResult.js.map