/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { TreeStoredSchema, TreeNodeSchemaIdentifier, TreeFieldStoredSchema } from "../core";
import { FlexTreeSchema, TreeNodeSchema, TreeFieldSchema } from "./typed-schema";
/**
 * Creates a new view schema using the stored schema.
 * @remarks
 * This is really only suitable for use with code that happens to need access to things which require a view schema, but isn't actually schema aware.
 * If the input schema came from a view schema, it will not return the same view schema, and will not be compatible:
 * the returned TreeSchema is simply one which schematize will not object to.
 * Assumes the schema uses the default field kinds.
 * @internal
 */
export declare function treeSchemaFromStoredSchema(schema: TreeStoredSchema): FlexTreeSchema;
export declare function fieldSchemaFromStoredSchema(schema: TreeFieldStoredSchema, map: ReadonlyMap<TreeNodeSchemaIdentifier, TreeNodeSchema>): TreeFieldSchema;
//# sourceMappingURL=storedToViewSchema.d.ts.map