/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { IJsonCodec, ICodecOptions, ICodecFamily } from "../codec";
import { ChangeEncodingContext } from "../core";
import { EncodedModularChangeset, ModularChangeset } from "../feature-libraries";
import { SharedTreeChange } from "./sharedTreeChangeTypes";
import { EncodedSharedTreeChange } from "./sharedTreeChangeFormat";
export declare function makeSharedTreeChangeCodec(modularChangeCodec: IJsonCodec<ModularChangeset, EncodedModularChangeset, EncodedModularChangeset, ChangeEncodingContext>, codecOptions: ICodecOptions): IJsonCodec<SharedTreeChange, EncodedSharedTreeChange, EncodedSharedTreeChange, ChangeEncodingContext>;
export declare function makeSharedTreeChangeCodecFamily(modularChangeCodec: IJsonCodec<ModularChangeset, EncodedModularChangeset, EncodedModularChangeset, ChangeEncodingContext>, options: ICodecOptions): ICodecFamily<SharedTreeChange, ChangeEncodingContext>;
//# sourceMappingURL=sharedTreeChangeCodecs.d.ts.map