/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
/**
 * An iterator that supports having items pushed onto it for later iteration.
 */
export declare class StackyIterator<T> implements Iterator<T>, Iterable<T> {
    private readonly list;
    private readonly stack;
    private index;
    constructor(list: readonly T[]);
    [Symbol.iterator](): Iterator<T>;
    next(): IteratorResult<T>;
    get done(): boolean;
    push(item: T): void;
    pop(): T | undefined;
    peek(): T | undefined;
}
//# sourceMappingURL=stackyIterator.d.ts.map