/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { ValueSchema } from "../../core";
import { TreeFieldSchema } from "../../feature-libraries";
/**
 * Types allowed as roots of Json content.
 */
export declare const jsonRoot: readonly [() => import("../../feature-libraries").MapNodeSchema<"com.fluidframework.json.object", TreeFieldSchema<import("../../feature-libraries").Optional, readonly [any, () => import("../../feature-libraries").FieldNodeSchema<"com.fluidframework.json.array", TreeFieldSchema<import("../../feature-libraries").Sequence, readonly [any, any, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, () => import("../../feature-libraries").FieldNodeSchema<"com.fluidframework.json.array", TreeFieldSchema<import("../../feature-libraries").Sequence, readonly [() => import("../../feature-libraries").MapNodeSchema<"com.fluidframework.json.object", TreeFieldSchema<import("../../feature-libraries").Optional, readonly [any, any, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, any, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>];
export declare const jsonObject: import("../../feature-libraries").MapNodeSchema<"com.fluidframework.json.object", TreeFieldSchema<import("../../feature-libraries").Optional, readonly [() => import("../../feature-libraries").MapNodeSchema<"com.fluidframework.json.object", TreeFieldSchema<import("../../feature-libraries").Optional, readonly [any, () => import("../../feature-libraries").FieldNodeSchema<"com.fluidframework.json.array", TreeFieldSchema<import("../../feature-libraries").Sequence, readonly [any, any, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, () => import("../../feature-libraries").FieldNodeSchema<"com.fluidframework.json.array", TreeFieldSchema<import("../../feature-libraries").Sequence, readonly [() => import("../../feature-libraries").MapNodeSchema<"com.fluidframework.json.object", TreeFieldSchema<import("../../feature-libraries").Optional, readonly [any, any, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, any, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>;
export declare const jsonArray: import("../../feature-libraries").FieldNodeSchema<"com.fluidframework.json.array", TreeFieldSchema<import("../../feature-libraries").Sequence, readonly [() => import("../../feature-libraries").MapNodeSchema<"com.fluidframework.json.object", TreeFieldSchema<import("../../feature-libraries").Optional, readonly [any, () => import("../../feature-libraries").FieldNodeSchema<"com.fluidframework.json.array", TreeFieldSchema<import("../../feature-libraries").Sequence, readonly [any, any, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, () => import("../../feature-libraries").FieldNodeSchema<"com.fluidframework.json.array", TreeFieldSchema<import("../../feature-libraries").Sequence, readonly [() => import("../../feature-libraries").MapNodeSchema<"com.fluidframework.json.object", TreeFieldSchema<import("../../feature-libraries").Optional, readonly [any, any, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, any, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.number", ValueSchema.Number>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.boolean", ValueSchema.Boolean>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.string", ValueSchema.String>, import("../../feature-libraries").LeafNodeSchema<"com.fluidframework.leaf.null", ValueSchema.Null>]>>;
export declare const jsonSchema: import("../../feature-libraries").SchemaLibrary;
//# sourceMappingURL=jsonDomainSchema.d.ts.map